"use strict";
// from https://github.com/Xotic750/get-function-name-x/blob/master/index.js
Object.defineProperty(exports, "__esModule", { value: true });
var isFn_1 = require("../preds/isFn");
var whiteSpace_1 = require("./whiteSpace");
var _getFnName;
if ((function test() { }).name !== 'test') {
    var STRIP_COMMENTS = /((\/\/.*$)|(\/\*[\s\S]*?\*\/))/mg;
    var fToString = Function.prototype.toString;
    var pMatch = String.prototype.match;
    var pReplace = String.prototype.replace;
    var reName = new RegExp('^[' + whiteSpace_1.default + ']*(?:function|class)[' + whiteSpace_1.default + ']*\\*?[' + whiteSpace_1.default + ']+([\\w\\$]+)[' + whiteSpace_1.default + ']*', 'i');
    _getFnName = function getName(fn) {
        var name = pMatch.call(pReplace.call(fToString.call(fn), STRIP_COMMENTS, ' '), reName);
        return name && name[1] !== 'anonymous' ? name[1] : '';
    };
}
else {
    /*jshint evil:true */
    if ((new Function()).name === 'anonymous') {
        _getFnName = function getName(fn) {
            return fn.name && fn.name !== 'anonymous' ? fn.name : '';
        };
    }
}
function getFunctionName(fn) {
    if (!isFn_1.default(fn)) {
        return null;
    }
    if (fn.__predToString) {
        return fn.__predToString();
    }
    return _getFnName ? _getFnName(fn) : fn.name;
}
exports.default = getFunctionName;
//# sourceMappingURL=fnName.js.map