"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fnName_1 = require("./fnName");
var clauseFromAlts_1 = require("./clauseFromAlts");
var core_1 = require("../core");
var delayed_1 = require("./delayed");
var match_1 = require("./match");
var coerceIntoClause_1 = require("./coerceIntoClause");
var preds_1 = require("../preds");
var Recursive = (function () {
    function Recursive(expression) {
        this.isRecursive = true;
        this.expression = expression;
    }
    ;
    return Recursive;
}());
exports.Recursive = Recursive;
function QuotedParamsMap(map) {
    Object.assign(this, map);
}
exports.QuotedParamsMap = QuotedParamsMap;
function UnquotedParamsMap(map) {
    Object.assign(this, map);
}
exports.UnquotedParamsMap = UnquotedParamsMap;
function Quoted(val) {
    this.value = val;
}
var ParamLabelClause = core_1.or('str', preds_1.isStr, 'quoted', preds_1.instanceOf(Quoted));
function genClauses(headClause) {
    var paramItemC = core_1.or('sExpression', delayed_1.default(function () { return sExprC; }), 'quotedParamsMap', delayed_1.default(function () { return QuotedParamsMapC; }), 'unquotedParamsMap', delayed_1.default(function () { return UnquotedParamsMapC; }), 'optionsObj', preds_1.isPlainObj, 'recursive', preds_1.instanceOf(Recursive));
    var sExprC = core_1.wall(core_1.cat('head', headClause, 'params', core_1.or('labelled', core_1.zeroOrMore(core_1.cat('label', ParamLabelClause, 'item', delayed_1.default(function () { return paramItemC; }))), 'unlabelled', core_1.zeroOrMore(core_1.cat('item', delayed_1.default(function () { return paramItemC; }))))));
    var ParamsMapC = core_1.mapOf(core_1.any, core_1.maybe(core_1.or('keyList', core_1.zeroOrMore(delayed_1.default(function () { return ParamLabelClause; })), 'singleParam', delayed_1.default(function () { return paramItemC; }))));
    var QuotedParamsMapC = core_1.and(preds_1.instanceOf(QuotedParamsMap), delayed_1.default(function () { return ParamsMapC; }));
    var UnquotedParamsMapC = core_1.and(preds_1.instanceOf(UnquotedParamsMap), delayed_1.default(function () { return ParamsMapC; }));
    return [sExprC, paramItemC];
}
exports.genClauses = genClauses;
exports.SExpressionClause = (_a = genClauses(core_1.ExprClause), _a[0]), exports.ParamItemClause = _a[1];
var singleArgParamGenerator = function (repo, _a) {
    var enclosedClause = _a.opts.enclosedClause;
    return [_createSExpr(repo, enclosedClause)];
};
var multipleArgParamGenerator = function (repo, _a) {
    var named = _a.opts.named, exprs = _a.exprs;
    if (exprs.length === 0) {
        //empty case
        return [];
    }
    else if (named) {
        var r = exprs.reduce(function (acc, _a) {
            var name = _a.name, expr = _a.expr;
            return acc.concat([new Quoted(name), _createSExpr(repo, expr)]);
        }, []);
        return r;
    }
    else {
        return exprs.reduce(function (acc, _a) {
            var expr = _a.expr;
            return acc.concat([_createSExpr(repo, expr)]);
        }, []);
    }
};
var sParamsConverters = {
    'PRED': function () { return []; },
    'WALL': function (repo, _a) {
        var enclosedClause = _a.opts.enclosedClause;
        return [_createSExpr(repo, enclosedClause)];
    },
    'AND': function (repo, _a) {
        var conformedExprs = _a.opts.conformedExprs;
        return conformedExprs.map(clauseFromAlts_1.default).map(function (c) { return _createSExpr(repo, c); });
    },
    'CAT': multipleArgParamGenerator,
    'OR': multipleArgParamGenerator,
    'Z_OR_M': singleArgParamGenerator,
    'O_OR_M': singleArgParamGenerator,
    'Z_OR_O': singleArgParamGenerator,
    'COLL_OF': singleArgParamGenerator,
    'ANY': function () { return []; },
    'MAP_OF': function (repo, _a) {
        var opts = _a.opts;
        return _handleKeyValExprPair(repo, opts);
    },
    'SHAPE': function (repo, _a) {
        var _b = _a.opts.conformedArgs.shapeArgs, _c = _b.optionalFields, _d = _c === void 0 ? {} : _c, _e = _d.opt, opt = _e === void 0 ? null : _e, _f = _d.optional, optional = _f === void 0 ? null : _f, _g = _b.requiredFields, _h = _g === void 0 ? {} : _g, _j = _h.req, req = _j === void 0 ? null : _j, _k = _h.required, required = _k === void 0 ? null : _k;
        return Object.assign(new UnquotedParamsMap(), (req || required) ? {
            required: _fieldDefToFrags(repo, req || required),
        } : {}, (opt || optional) ? {
            optional: _fieldDefToFrags(repo, opt || optional),
        } : {});
    },
    'FCLAUSE': function (repo, _a) {
        var _b = _a.opts, args = _b.args, ret = _b.ret, fn = _b.fn;
        return Object.assign(new UnquotedParamsMap(), args ? { args: _createSExpr(repo, args) } : {}, ret ? { ret: _createSExpr(repo, ret) } : {}, fn ? { fn: [fnName_1.default(fn) + "()"] } : {});
    }
};
function _fieldDefToFrags(repo, _a) {
    var fieldDefs = _a.fieldDefs, keyList = _a.keyList;
    if (fieldDefs) {
        var r = new QuotedParamsMap();
        for (var key in fieldDefs) {
            if (fieldDefs.hasOwnProperty(key)) {
                var val = match_1.default(fieldDefs[key], {
                    'keyValExprPair': function (pair) { return _handleKeyValExprPair(repo, pair); },
                    'valExpressionOnly': function (expr) { return _createSExpr(repo, clauseFromAlts_1.default(expr)); }
                }, function () {
                    throw '!g';
                });
                Object.assign(r, (_b = {},
                    _b[key] = val,
                    _b));
            }
        }
        return r;
    }
    else if (keyList) {
        return keyList;
    }
    else {
        throw '!w';
    }
    var _b;
}
function _handleKeyValExprPair(repo, _a) {
    var keyExpression = _a.keyExpression, valExpression = _a.valExpression;
    return new UnquotedParamsMap({
        'key': _createSExpr(repo, clauseFromAlts_1.default(keyExpression)),
        'val': _createSExpr(repo, clauseFromAlts_1.default(valExpression)),
    });
}
function _params(repo, clause) {
    var converter = sParamsConverters[clause.type];
    if (!converter) {
        console.error(clause);
        throw new Error("Unsupported clause type " + clause.type + ".");
    }
    else {
        var r = converter(repo, clause);
        return r;
    }
}
function _createSExpr(repo, expr) {
    if (_exists(repo, expr)) {
        return new Recursive(expr);
    }
    var coercedExpr = coerceIntoClause_1.default(expr), realExpr, newRepo = repo;
    if (coercedExpr.type === 'DELAYED' ||
        coercedExpr.type === 'CLAUSE_REF') {
        realExpr = coercedExpr.get();
        return _createSExpr(repo, realExpr);
    }
    else {
        realExpr = coercedExpr;
        newRepo = _addToRepo(repo, coercedExpr);
    }
    var params = _params(newRepo, realExpr);
    return [realExpr].concat(params);
}
function _addToRepo(repo, expr) {
    if (!_exists(repo, expr)) {
        return repo.concat([expr]);
    }
}
function _exists(repo, piece) {
    return repo.indexOf(piece) >= 0;
}
function sExpression(expr) {
    var repo = [];
    return _createSExpr(repo, expr);
}
exports.default = sExpression;
var _a;
//# sourceMappingURL=sExpression.js.map