"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function lazyDefine(obj, prop, fn) {
    var define = function (value) { return Object.defineProperty(obj, prop, { value: value, enumerable: true, writable: true }); };
    Object.defineProperty(obj, prop, {
        configurable: true,
        enumerable: true,
        get: function () {
            var ret = fn();
            define(ret);
            return ret;
        },
        set: function (val) {
            define(val);
        }
    });
    return obj;
}
exports.default = lazyDefine;
//# sourceMappingURL=lazyDefine.js.map