"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var clauseFromAlts_1 = require("../utils/clauseFromAlts");
var isProblem_1 = require("../utils/isProblem");
var Problem_1 = require("../models/Problem");
function mapOfWalker(clause, walkFn) {
    var _a = clause.opts, keyExpression = _a.keyExpression, valExpression = _a.valExpression;
    var keyClause = keyExpression && clauseFromAlts_1.default(keyExpression);
    var valClause = valExpression && clauseFromAlts_1.default(valExpression);
    return {
        trailblaze: mapOfTrailblaze,
        reconstruct: mapOfReconstruct,
    };
    function mapOfTrailblaze(x, walkOpts) {
        var guide = {};
        for (var key in x) {
            if (x.hasOwnProperty(key)) {
                var keyR = walkFn(keyClause, key, walkOpts);
                if (isProblem_1.default(keyR)) {
                    return new Problem_1.default(x, clause, (_a = {}, _a[key] = keyR, _a), "mapOf: key " + key + " failed validation");
                }
                var valR = walkFn(valClause, x[key], walkOpts);
                if (isProblem_1.default(valR)) {
                    return new Problem_1.default(x, clause, (_b = {}, _b[key] = valR, _b), "mapOf: value for key " + key + " failed validation");
                }
                guide[key] = {
                    expr: valClause,
                    valGuide: valR,
                };
            }
        }
        return guide;
        var _a, _b;
    }
    function mapOfReconstruct(guide, walkOpts) {
        var r = {};
        for (var key in guide) {
            var _a = guide[key], expr = _a.expr, valGuide = _a.valGuide;
            r[key] = walkFn(expr, valGuide, walkOpts);
        }
        return r;
    }
}
exports.default = mapOfWalker;
//# sourceMappingURL=mapOfWalker.js.map